package betterwithmods.module.gameplay;

import betterwithmods.common.BWMBlocks;
import betterwithmods.common.items.ItemMaterial;
import betterwithmods.common.registry.OreStack;
import betterwithmods.common.registry.bulk.manager.CrucibleManager;
import betterwithmods.common.registry.bulk.manager.StokedCrucibleManager;
import betterwithmods.module.Feature;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.oredict.OreDictionary;

/**
 * Created by primetoxinz on 5/16/17.
 */
public class CrucibleRecipes extends Feature {
    public CrucibleRecipes() {
        canDisable = false;
    }

    @Override
    public void init(FMLInitializationEvent event) {
        addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT), new Object[]{new OreStack("nuggetDiamond", 9)});
        addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL), new Object[]{new OreStack("nuggetSoulforgedSteel", 9)});
        addStokedCrucibleRecipe(new ItemStack(Blocks.field_150359_w), new Object[]{new ItemStack(Blocks.field_150354_m, 1, OreDictionary.WILDCARD_VALUE)});
        addStokedCrucibleRecipe(new ItemStack(Blocks.field_150359_w, 3), new Object[]{new ItemStack(Blocks.field_150410_aZ, 8)});
        addStokedCrucibleRecipe(new ItemStack(Blocks.field_150348_b), new Object[]{new ItemStack(Blocks.field_150347_e)});
        addStokedCrucibleRecipe(new ItemStack(BWMBlocks.AESTHETIC, 1, 6), new Object[]{new ItemStack(BWMBlocks.AESTHETIC, 1, 7)});
        addCrucibleRecipe(new ItemStack(Blocks.field_150360_v, 1, 0), new Object[]{new ItemStack(Blocks.field_150360_v, 1, 1)});
        addCrucibleRecipe(new ItemStack(Blocks.field_150360_v, 1, 0), new ItemStack(Items.field_151131_as), new Object[]{new ItemStack(Blocks.field_150360_v, 1, 1), new ItemStack(Items.field_151133_ar)});
        addStokedCrucibleRecipe(new ItemStack(Blocks.field_150348_b, 1, 1), new Object[] {new ItemStack(BWMBlocks.COBBLE, 1, 0)});
        addStokedCrucibleRecipe(new ItemStack(Blocks.field_150348_b, 1, 3), new Object[] {new ItemStack(BWMBlocks.COBBLE, 1, 1)});
        addStokedCrucibleRecipe(new ItemStack(Blocks.field_150348_b, 1, 5), new Object[] {new ItemStack(BWMBlocks.COBBLE, 1, 2)});
    }

    public static void addCrucibleRecipe(ItemStack output, Object[] inputs) {
        CrucibleManager.getInstance().addRecipe(output, ItemStack.field_190927_a, inputs);
    }

    public static void addCrucibleRecipe(ItemStack output, ItemStack secondary, Object[] inputs) {
        CrucibleManager.getInstance().addRecipe(output, secondary, inputs);
    }

    public static void addStokedCrucibleRecipe(ItemStack output, Object[] inputs) {
        StokedCrucibleManager.getInstance().addRecipe(output, inputs);
    }

    public static void addStokedCrucibleRecipe(ItemStack output, ItemStack secondary, Object[] inputs) {
        StokedCrucibleManager.getInstance().addRecipe(output, secondary, inputs);
    }
}
